{
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

DISCLAIMER

This program implements a secure erase of disk media as per the
Department of Defense clearing and sanitizing standard: DOD 5220.22-M

The standard states that hard disk media is erased by
overwriting with a character, then the character's complement,
and then a random character. Note that the standard specicically
states that this method is not suitable for TOP SECRET information.
TOP SECRET data sanatizing is only achievable by a Type 1 or 2
degauss of the disk, or by disintegrating, incinerating,
pulverizing, shreding, or melting the disk.
}
program wp;
{$APPTYPE CONSOLE}
uses
  Windows, SysUtils, Classes;

var
everythingOK: boolean;
errors, files, directories:integer;
buffer: array [0..4095] of Byte;


//fill buffer with characters
//0 = with 0, 1 = with 1 and 2 = random
procedure fill(chr:integer);
var i: integer;
begin
   if chr=0 then
   begin
    for i := Low(buffer) to High(buffer) do
      buffer[i] := 0;
      exit;
   end;

   if chr=1 then
   begin
    for i := Low(buffer) to High(buffer) do
      buffer[i] := 1;
      exit;
   end;

   if chr=2 then
   begin
    for i := Low(buffer) to High(buffer) do
      buffer[i] := Random(256);
      exit;
   end;
end;

procedure SecureDelete(pass:integer;FileName: string);
var
  max, n: LongInt;
  i: Integer;
  fs: TFileStream;
  rena:string;                   // renames file to delete
begin
  try
    if RenameFile(filename,extractfilepath(filename)+'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa.aaaaaaa') then
    begin
     rena:=extractfilepath(filename)+'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa.aaaaaaa';
     filename:=rena;
    end;
  except
    writeln('wp: error renaming file: '+filename);
    everythingOK:=False;
    errors:=errors+1;
    Exit;
  end;

  fs := TFilestream.Create(FileName, fmOpenReadWrite or fmShareExclusive);
  try
    for i := 1 to pass do
    begin
      write('.');
      //with zeros
      fill(0);
      max := fs.Size;
      fs.Position := 0;
      while max > 0 do
      begin
        if max > SizeOf(buffer) then
          n := SizeOf(buffer)
        else
          n := max;
        fs.Write(Buffer, n);
        max := max - n;
      end;
      FlushFileBuffers(fs.Handle);

      //with ones
      fill(1);
      max := fs.Size;
      fs.Position := 0;
      while max > 0 do
      begin
        if max > SizeOf(buffer) then
          n := SizeOf(buffer)
        else
          n := max;
        fs.Write(Buffer, n);
        max := max - n;
      end;
      FlushFileBuffers(fs.Handle);

      //with random data
      fill(2);
      max := fs.Size;
      fs.Position := 0;
      while max > 0 do
      begin
        if max > SizeOf(buffer) then
          n := SizeOf(buffer)
        else
          n := max;
        fs.Write(Buffer, n);
        max := max - n;
      end;
      FlushFileBuffers(fs.Handle);
    end;
    fs.Free;
  except
    on E: Exception do
    begin
      writeln('wp: error wiping: '+filename+': '+E.Message);
      fs.Free;
      everythingOK:=False;
      errors:=errors+1;
      Exit;
    end;
  end;
  try
    Deletefile(pchar(FileName));
  except
    on E: Exception do
    begin
      writeln('wp: error deleting: '+filename+': '+E.Message);
      fs.Free;
      everythingOK:=False;
      errors:=errors+1;
      Exit;
    end;
  end;
  files:=files+1;
  writeln(' OK');
  everythingOK:=true;
end;


procedure DelTree(dir: string);
var
Search : TSearchRec;
ok, tmp: integer;
attributes,newattributes:word;
begin
ok := FindFirst(dir + '\*.*',faAnyFile,Search);
while ok = 0 do  begin
  if ((Search.Name <> '.' ) and (Search.Name <> '..')) then
  begin
    if ((Search.Attr and faDirectory) > 0) then
    begin
        //remove read-only attr
        try
          attributes:=filegetattr(Search.Name);
          newattributes:=attributes;
          newattributes:=newattributes and not faReadOnly;
          filesetattr(Search.Name,newattributes);
        except
          writeln('wp: FAILED when trying to remove read-only attr on '+Search.Name);
        end;
        writeln('entering '+dir + '\' + Search.Name);
        DelTree(dir + '\' + Search.Name);
    end
    else
    begin
        //remove read-only attr
        try
          attributes:=filegetattr(Search.Name);
          newattributes:=attributes;
          newattributes:=newattributes and not faReadOnly;
          tmp:=filesetattr(dir + '\' +Search.Name, {Attributes and not faReadOnly}newattributes);
          if tmp<>0 then
             writeln('wp: FAILED when trying to remove read-only attr on '+Search.Name+'. error='+inttostr(tmp));

        except
          writeln('wp: FAILED when trying to remove read-only attr on '+Search.Name);
        end;
        // do something with the file
        write('wiping '+dir + '\' + Search.Name);
        SecureDelete(strtoint(paramstr(1)),dir + '\' + Search.Name);
    end;
  end;
  ok := FindNext(Search);
end;
FindClose(Search);
try
  if everythingOK then
  begin
    write('wiping '+dir);
    {-I}
    RmDir(dir);
    {+I}
    if IOResult <> 0 then
    begin
      writeln;
      writeln('wp: error wiping directory '+dir);
    end
    else
    begin
      directories:=directories+1;
      writeln(' OK');
    end;
  end;
except
  on EInOutError do writeln('Couldn''t remove '+dir);
end;
end;



procedure delfile(filename:string);
var
    Found: integer;
    SRec: TSearchRec;
    attributes,newattributes:word;
begin
   { Use FindFirst so we can specify wild cards in the filename }
    Found:= FindFirst(filename,faReadOnly or faSysFile or faArchive or faSysFile,SRec);
    if Found<> 0 then
    begin
      Writeln('wp: file not found: ',filename);
      errors:=errors+1;
      exit;
    end;
    while Found=0 do
    begin
      try
        attributes:=filegetattr(SRec.Name);
        newattributes:=attributes;
        newattributes:=newattributes and not faReadOnly;
        filesetattr(SRec.Name,newattributes);
      except
        writeln;
        writeln('wp: can''t wipe '+SRec.Name+', file might be in use.');
        writeln('wipe stopped.');
        errors:=errors+1;
        everythingOK:=false;
        exit;
      end;

      write('wiping '+SRec.Name);
      SecureDelete(strtoint(paramstr(1)),SRec.Name);
      if not everythingOK then
         writeln('wp: couldn''t wipe '+filename);

      Found:= FindNext(SRec);   { Find the next file }
    end;
    FindClose(SRec);
end;

//variables
var
    attributes:word;
    ii: integer;//added
    Sure: char;

begin
everythingOK:=false;
errors:=0;
files:=0;
directories:=0;

if (paramcount<2) or (paramstr(1)='-?') or (paramstr(1)='/?') then
begin
  writeln('WP - wipes files in a secure way.');
  writeln('version 3.2 - By Uri Fridman. urifrid@yahoo.com');
  writeln('www.geocities.com/urifrid');
  writeln;
  writeln('Usage:');
  writeln('      wp <No. of passes> filename1 [<filename2> ...]');
  writeln;
  writeln('this software is covered by the GNU Public License (GPL) version'+#13+#10+
          '2 or later. This is free software, there are no warranties or'+#13+#10+
          'guarantees. You can copy, modify and distribute this code'+#13+#10+
          'according to the GPL. The license itself is located in a file'+#13+#10+
          'called COPYING in the same directory you retrieved this file from.');
  exit;
end;

writeln;

try
  strtoint(paramstr(1));
except
  writeln('Parameter #1 [No. of passes] should be a number.');
  writeln('Type "wp -?" for help.');
  exit;
end;

writeln;
writeln('Once wiped the files cannot be recovered,');
write('are you sure you want to wipe the file(s)? (y,n): ');
readln(Sure);
if (Sure<>'Y') and (Sure<>'y') then
begin
  writeln('File Wipe aborted.');
  exit;
end;
writeln;
writeln('wiping with '+paramstr(1)+' passes:');

for ii:= 2 to ParamCount do  { Cycle through all the files specified added}
begin

  attributes:=filegetattr(paramstr(ii));
  if attributes=faDirectory then //is it a directory
  begin
    DelTree(ExpandFileName(paramstr(ii)));
  end
  else //it's a file
  begin
    delfile(paramstr(ii));
  end;
end;
writeln;
writeln('wiped '+inttostr(files)+' files and '+inttostr(directories)+' directories');
writeln('there were '+inttostr(errors)+' errors');
end.

